
{$I+}

uses CRT;

const LPT=$378;

var YM3f:file;
    Name:string;
    Volume:dword;
    Buffer:pointer;
    Offset:dword;
    N:dword=0;
    c:char;
    f:byte=0;
    Frequency:dword=16667;

procedure D(b:byte);
begin
 Port[LPT]:=b;
end;

procedure AD(b:byte);
begin
 Port[LPT+2]:=Port[LPT+2] and $FB or b shl 2;
end;

procedure R(b:byte);
begin
 Port[LPT+2]:=Port[LPT+2] and $F7 or b shl 3;
end;

procedure ResetYM2149;
begin
 R(1);
 R(0);
 R(1);
end;

procedure OutYM2149(Address,Data:byte);
begin
 AD(1);
 D(Address);
 AD(0);
 D(Data);
end;

procedure Frame;
var i:dword;
begin
 for i:=0 to 13 do OutYM2149(i,Mem[DWORD(Buffer)+4+Offset*i+N]);
end;

procedure ShowFrequency;
begin
 GotoXY(1,5);
 Write('Frequency[f,F]:');
 if Frequency=16667 then Write('60Hz') else Write('50Hz');
end;

procedure Delay(Time:dword);
assembler;
asm
 mov      ah,$86
 mov      cx,WORD PTR Time[2]
 mov      dx,WORD PTR Time[0]
 int      $15
end;

procedure OffCursor;
assembler;
asm
 mov      ah,1
 mov      ch,$20
 int      $10
end;

BEGIN
 TextMode(CO40);
 TextColor(15);
 WriteLn('YM2149 Player');
 WriteLn('(C) Romanich 2006');
 WriteLn;
 TextColor(9);
 Write('YM3:');
 TextColor(9);
 ReadLn(Name);
 OffCursor;
 if Name='' then Halt;
 Assign(YM3f,Name);
 ReSet(YM3f,1);
 Volume:=FileSize(YM3f);
 GetMem(Buffer,Volume);
 BlockRead(YM3f,Buffer^,Volume);
 Close(YM3f);
 Offset:=Volume div 14;
 ShowFrequency;
 Inline($FA);
 ResetYM2149;
 repeat
  c:=#$FF;
  if KeyPressed then c:=ReadKey;
  if (c='f') or (c='F') then begin
   Inc(f);
   if f>1 then f:=0;
   if f=0 then Frequency:=16667 else Frequency:=20000;
   ShowFrequency;
  end;
  Frame;
  Delay(Frequency);
  Inc(N);
  if N=Offset then N:=0;
 until c=#27;
 ResetYM2149;
 Inline($FB);
 FreeMem(Buffer,Volume);
 TextMode(CO80+Font8x8);
END.