
{$I+}

uses CRT;

const LPT=$378;

var YM5f:file;
    Name:string;
    Buffer:pointer;
    InterLeave:boolean;
    Volume,Frequency,Loop,K,N,Point:dword;

procedure D(b:byte);
begin
 Port[LPT]:=b;
end;

procedure AD(b:byte);
begin
 Port[LPT+2]:=Port[LPT+2] and $FB or b shl 2;
end;

procedure R(b:byte);
begin
 Port[LPT+2]:=Port[LPT+2] and $F7 or b shl 3;
end;

procedure ResetYM2149;
begin
 R(1);
 R(0);
 R(1);
end;

procedure OutYM2149(Address,Data:byte);
begin
 AD(1);
 D(Address);
 AD(0);
 D(Data);
end;

procedure Frame;
var i:dword;
begin
 for i:=0 to 13 do if InterLeave then OutYM2149(i,Mem[DWORD(Buffer)+Point+K*i+N]) else OutYM2149(i,Mem[DWORD(Buffer)+Point+N shl 4+i]);
end;

procedure Delay(Time:dword);
assembler;
asm
 mov      ah,$86
 mov      cx,WORD PTR Time[2]
 mov      dx,WORD PTR Time[0]
 int      $15
end;

procedure OffCursor;
assembler;
asm
 mov      ah,1
 mov      ch,$20
 int      $10
end;

BEGIN
 TextMode(CO40);
 TextColor(15);
 WriteLn('YM2149 Player');
 WriteLn('(C) Romanich 2006');
 TextColor(9);
 Write('YM5:');
 TextColor(9);
 ReadLn(Name);
 OffCursor;
 if Name='' then Halt;
 Assign(YM5f,Name);
 ReSet(YM5f,1);
 Volume:=FileSize(YM5f);
 GetMem(Buffer,Volume);
 BlockRead(YM5f,Buffer^,Volume);
 Close(YM5f);
 if Mem[DWORD(Buffer)+$13] and 1=1 then InterLeave:=true else InterLeave:=false;
 Frequency:=1000000 div Mem[DWORD(Buffer)+$1B];
 asm
  mov       esi,Buffer
  add       esi,$1C
  mov       eax,[esi]
  bswap     eax
  mov       Loop,eax
  mov       esi,Buffer
  add       esi,$0C
  mov       eax,[esi]
  bswap     eax
  mov       K,eax
 end;
 Point:=Volume-16*K-4;
 N:=Loop;
 Inline($FA);
 ResetYM2149;
 repeat
  Frame;
  Delay(Frequency);
  Inc(N);
  if N=K then N:=Loop;
 until Port[$60]=1;
 ResetYM2149;
 Inline($FB);
 FreeMem(Buffer,Volume);
 TextMode(CO80+Font8x8);
END.